
package xmlunleashed.ch10.jaxb;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import javax.xml.bind.Dispatcher;
import javax.xml.bind.InvalidAttributeException;
import javax.xml.bind.InvalidContentObjectException;
import javax.xml.bind.LocalValidationException;
import javax.xml.bind.MarshallableObject;
import javax.xml.bind.MarshallableRootElement;
import javax.xml.bind.Marshaller;
import javax.xml.bind.PredicatedLists;
import javax.xml.bind.PredicatedLists.Predicate;
import javax.xml.bind.RootElement;
import javax.xml.bind.StructureValidationException;
import javax.xml.bind.UnmarshalException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.ValidatableObject;
import javax.xml.bind.Validator;
import javax.xml.marshal.XMLScanner;
import javax.xml.marshal.XMLWriter;
import xmlunleashed.ch10.jaxb.RentalProperty;


public class RentalPropertyList
    extends MarshallableRootElement
    implements RootElement
{

    private List _RentalProperty = PredicatedLists.createInvalidating(this, new RentalPropertyPredicate(), new ArrayList());
    private PredicatedLists.Predicate pred_RentalProperty = new RentalPropertyPredicate();

    public List getRentalProperty() {
        return _RentalProperty;
    }

	/**
	 *  Added by Darby - generated code did not provide an "add" method
	 */
	public void addRentalProperty(RentalProperty theProp) {
		_RentalProperty.add(theProp);
		invalidate();
	}

    public void deleteRentalProperty() {
        _RentalProperty = null;
        invalidate();
    }

    public void emptyRentalProperty() {
        _RentalProperty = PredicatedLists.createInvalidating(this, pred_RentalProperty, new ArrayList());
    }

    public void validateThis()
        throws LocalValidationException
    {
    }

    public void validate(Validator v)
        throws StructureValidationException
    {
        for (Iterator i = _RentalProperty.iterator(); i.hasNext(); ) {
            v.validate(((ValidatableObject) i.next()));
        }
    }

    public void marshal(Marshaller m)
        throws IOException
    {
        XMLWriter w = m.writer();
        w.start("rental_property_list");
        if (_RentalProperty.size()> 0) {
            for (Iterator i = _RentalProperty.iterator(); i.hasNext(); ) {
                m.marshal(((MarshallableObject) i.next()));
            }
        }
        w.end("rental_property_list");
    }

    public void unmarshal(Unmarshaller u)
        throws UnmarshalException
    {
        XMLScanner xs = u.scanner();
        Validator v = u.validator();
        xs.takeStart("rental_property_list");
        while (xs.atAttribute()) {
            String an = xs.takeAttributeName();
            throw new InvalidAttributeException(an);
        }
        {
            List l = PredicatedLists.create(this, pred_RentalProperty, new ArrayList());
            while (xs.atStart("rental_property")) {
                l.add(((RentalProperty) u.unmarshal()));
            }
            _RentalProperty = PredicatedLists.createInvalidating(this, pred_RentalProperty, l);
        }
        xs.takeEnd("rental_property_list");
    }

    public static RentalPropertyList unmarshal(InputStream in)
        throws UnmarshalException
    {
        return unmarshal(XMLScanner.open(in));
    }

    public static RentalPropertyList unmarshal(XMLScanner xs)
        throws UnmarshalException
    {
        return unmarshal(xs, newDispatcher());
    }

    public static RentalPropertyList unmarshal(XMLScanner xs, Dispatcher d)
        throws UnmarshalException
    {
        return ((RentalPropertyList) d.unmarshal(xs, (RentalPropertyList.class)));
    }

    public boolean equals(Object ob) {
        if (this == ob) {
            return true;
        }
        if (!(ob instanceof RentalPropertyList)) {
            return false;
        }
        RentalPropertyList tob = ((RentalPropertyList) ob);
        if (_RentalProperty!= null) {
            if (tob._RentalProperty == null) {
                return false;
            }
            if (!_RentalProperty.equals(tob._RentalProperty)) {
                return false;
            }
        } else {
            if (tob._RentalProperty!= null) {
                return false;
            }
        }
        return true;
    }

    public int hashCode() {
        int h = 0;
        h = ((127 *h)+((_RentalProperty!= null)?_RentalProperty.hashCode(): 0));
        return h;
    }

    public String toString() {
        StringBuffer sb = new StringBuffer("<<rental_property_list");
        if (_RentalProperty!= null) {
            sb.append(" rental_property=");
            sb.append(_RentalProperty.toString());
        }
        sb.append(">>");
        return sb.toString();
    }

    public static Dispatcher newDispatcher() {
        return Address.newDispatcher();
    }


    private static class RentalPropertyPredicate
        implements PredicatedLists.Predicate
    {


        public void check(Object ob) {
            if (!(ob instanceof RentalProperty)) {
                throw new InvalidContentObjectException(ob, (RentalProperty.class));
            }
        }

    }

}
