package xmlunleashed.ch10;

/**
 *  Describes exceptions for the Data Access Object (DAO)
 */
public class DAOException extends Exception {

	/**
	 *  The original exception
	 */
	private Exception rootCause;

	/**
	 *  Default constructor
	 */
	public DAOException() {
	}

	/**
	 *  Create an exception with the given message
	 */
	public DAOException(String msg) {
		super(msg);
	}

	/**
	 *  Create an exception based on the root cause exception
	 */
	public DAOException(Exception exc) {
		rootCause = exc;
	}

	/**
	 *  Returns the exception that was the root cause
	 */
	public Exception getRootCause() {
		return rootCause;
	}

	/**
	 *  Returns the message
	 */
	public String getMessage() {
		if (rootCause != null) {
			return rootCause.getMessage();
		}
		else {
			return super.getMessage();
		}
	}
}